SystemOrganization addCategory: #'TP Integrador Test'!

TestCase subclass: #TPIntegradorTest
	instanceVariableNames: 'pikachu jigglypuff meganium impactrueno amago golpazo descanso canto danzaPetalo sintesis hojaAfilada placaje destructor movimientosPikachu movimientosJigglypuff movimientosMeganium movimientos unaPokebola unEntrenador ash unaMedicina unaMedicinaEspecial moneda error'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP Integrador Test'!

TPIntegradorTest class
	instanceVariableNames: 'placaje'!

TPIntegradorTest class
	instanceVariableNames: 'placaje'!

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 21:04'!
setUp
pikachu:=SinEntrenador new.
jigglypuff:=ConEntrenador new.
meganium:=ConEntrenador new. 

movimientosMeganium:=Set new.
movimientosPikachu:=Set new.
movimientosJigglypuff:=Set new. 

pikachu movimientos:movimientosPikachu.
meganium movimientos:movimientosMeganium.
jigglypuff movimientos:movimientosJigglypuff. 

impactrueno:= Paralisis new.
amago:=MovimientoDanino new. 
amago puntosDeDao:30. 
golpazo:=MovimientoDanino new.
golpazo puntosDeDao:80.
descanso:=MovimientoCurativo new.
descanso puntosACurar:50.
canto:=Suenio new.
destructor:=MovimientoDanino new.
destructor puntosDeDao:30.
danzaPetalo:=Confusion new.
sintesis:=MovimientoCurativo new.
sintesis puntosACurar:100.
hojaAfilada:=MovimientoDanino new.
hojaAfilada puntosDeDao:55.
placaje:=MovimientoDanino new.
placaje puntosDeDao:50. 

pikachu tusPuntosDeVidaMax:80.
pikachu tusPuntosDeVida:60.
impactrueno usosDisponibles:5.
movimientosPikachu add:impactrueno.
amago usosDisponibles:10.
movimientosPikachu add:amago.
golpazo usosDisponibles:1. 
movimientosPikachu add:golpazo.
descanso usosDisponibles:1. 
movimientosPikachu add:descanso.

jigglypuff tusPuntosDeVidaMax:100.
jigglypuff tusPuntosDeVida:30.
canto usosDisponibles:2.
movimientosJigglypuff add:canto. 
descanso usosDisponibles:5.
movimientosJigglypuff add:descanso.
destructor usosDisponibles:10.
movimientosJigglypuff add:destructor. 

meganium tusPuntosDeVidaMax: 250.
meganium tusPuntosDeVida:50.
danzaPetalo usosDisponibles:3.
movimientosMeganium add:danzaPetalo. 
sintesis usosDisponibles:4.
movimientosMeganium add:sintesis.
hojaAfilada usosDisponibles:0.
movimientosMeganium add:hojaAfilada.
placaje usosDisponibles:5.
movimientosMeganium add:placaje. 

pikachu experiencia:42050.
jigglypuff experiencia:403289.
meganium experiencia:1010042.

unaMedicina:=Medicina new.
unaMedicina cantidadQueCura:40. 

unaPokebola:=Pokebola new.
unaMedicinaEspecial:=MedicinaEspecial new. 

moneda := MonedaTrucha new.
Moneda instance: moneda.




! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 20:55'!
testJigglyPuffCon0DeVidaNoPuedeLuchar
jigglypuff tusPuntosDeVida:0.
self assert:jigglypuff podesLuchar equals:false. 
! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 00:06'!
testJigglyPuffDuermeAPikachu
jigglypuff luchaCon:canto contra:pikachu. 
self assert: (pikachu condicion) equals:Dormido. ! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 20:50'!
testJigglyPuffTiene960DeGrositud.
self assert: jigglypuff cuantaGrositudTenes equals:960.! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 22:28'!
testJigglypuffConfundidoNoSePuedeMoverYUsaDescanso
jigglypuff condicion:Confundido new. 
self deny: jigglypuff noEstasAfectadoPorUnaCondicion. 
moneda resultadosEsperados: #(false).
[jigglypuff luchaCon:descanso contra:jigglypuff] on:Error do:[self assert: jigglypuff tusPuntosDeVida equals:0.
																									self assert: (jigglypuff condicion)class equals:Confundido.]. 
! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 20:10'!
testJigglypuffConfundidoSePuedeMoverYUsaDescanso
jigglypuff condicion:Confundido new. 
self deny: jigglypuff noEstasAfectadoPorUnaCondicion. 
moneda resultadosEsperados: #(true).
jigglypuff luchaCon:descanso  contra:jigglypuff.
self assert: jigglypuff tusPuntosDeVida equals:80.
self assert: (jigglypuff condicion)class equals:Confundido. 

! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 22:34'!
testJigglypuffDormidoNoSePuedeMoverYUsaDescanso
|vidaAlInicio|
vidaAlInicio:=jigglypuff tusPuntosDeVida. 
jigglypuff condicion:Dormido new. 
self deny: jigglypuff noEstasAfectadoPorUnaCondicion. 
moneda resultadosEsperados: #(false).
[jigglypuff luchaCon:descanso contra:jigglypuff] on:Error do:[self assert: jigglypuff tusPuntosDeVida equals:(vidaAlInicio).
																									self assert: (jigglypuff condicion)class equals:Dormido.]. 
! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 20:08'!
testJigglypuffDormidoSePuedeMoverYUsaDescanso
jigglypuff condicion:Dormido new. 
self deny: jigglypuff noEstasAfectadoPorUnaCondicion. 
moneda resultadosEsperados: #(true).
jigglypuff luchaCon:descanso  contra:jigglypuff.
self assert: jigglypuff tusPuntosDeVida equals:80.
self assert: (jigglypuff condicion)class equals:Normal. 

! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 00:19'!
testJigglypuffEsNivel6
self assert: jigglypuff nivel equals:6. ! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 22:35'!
testJigglypuffParalizadoNoSePuedeMoverYUsaDescanso
|vidaAlInicio|
vidaAlInicio:=jigglypuff tusPuntosDeVida. 
jigglypuff condicion:Paralizado new. 
self deny: jigglypuff noEstasAfectadoPorUnaCondicion.  
moneda resultadosEsperados: #(false).
[jigglypuff luchaCon:descanso contra:jigglypuff] on:Error do:[self assert: jigglypuff tusPuntosDeVida equals:(vidaAlInicio).
																									self assert: (jigglypuff condicion)class equals:Paralizado.]. 
! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 20:09'!
testJigglypuffParalizadoSePuedeMoverYUsaDescanso
jigglypuff condicion:Paralizado new. 
self deny: jigglypuff noEstasAfectadoPorUnaCondicion. 
moneda resultadosEsperados: #(true).
jigglypuff luchaCon:descanso  contra:jigglypuff.
self assert: jigglypuff tusPuntosDeVida equals:80.
self assert: (jigglypuff condicion)class equals:Paralizado. 

! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 19:58'!
testJigglypuffUsaDescansoContraPikachuCura50
|puntosIniciales|
puntosIniciales:=jigglypuff tusPuntosDeVida. 
jigglypuff luchaCon:descanso contra:jigglypuff.
self assert:jigglypuff tusPuntosDeVida equals:(puntosIniciales +50).! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/27/2013 20:47'!
testLeConvieneAPikachuUsarDescansoCon30
pikachu tusPuntosDeVida:30.
self assert: (descanso convieneQue:pikachu TeUseContra:pikachu). ! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/27/2013 20:24'!
testLeConvieneAPikachuUsarGolpazoYAmagoContraMeganium
self assert:(golpazo convieneQue:pikachu TeUseContra:meganium).
self assert:(amago convieneQue:pikachu TeUseContra:meganium).! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 16:25'!
testLeConvieneAPikachuUsarImpactruenoContraMeganium
self assert: (impactrueno convieneQue:pikachu TeUseContra:meganium). ! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/27/2013 20:46'!
testLeConvieneUsarDescansoAAsh
jigglypuff tePuedenSacrificar ifFalse:[
self assert:(golpazo convieneQue:jigglypuff TeUseContra:jigglypuff)]. ! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 19:52'!
testMeganiumEsNivel7
self assert:meganium nivel equals:7. ! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 20:50'!
testMeganiumTiene2450DeGrositud
self assert: meganium cuantaGrositudTenes equals:2450. ! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 00:11'!
testMeganiumUsaDanzaPetaloContraJigglypuffQuedaConfundido
meganium luchaCon:danzaPetalo contra:jigglypuff.
self assert:(jigglypuff condicion) equals:Confundido.  ! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/27/2013 18:56'!
testMovimientosDisponiblesMeganium
|disponibles|
disponibles:=Set new. 
disponibles add:danzaPetalo.
disponibles add:sintesis.
disponibles add:placaje.

self assert: meganium movimientosDisponibles equals:disponibles.! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/27/2013 20:47'!
testNoLeConvieneAPikachuUsarDescanso
self deny: (descanso convieneQue:pikachu TeUseContra:pikachu).! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/27/2013 19:23'!
testNoLeConvieneAPikachuUsarGolpazoContraJigglypuff
self deny: (golpazo convieneQue:pikachu TeUseContra:jigglypuff).! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 00:01'!
testNoLeConvieneAPikachuUsarImpactruenoContraJigglypuff
self deny:(impactrueno convieneQue:pikachu TeUseContra:jigglypuff). ! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 20:05'!
testNoLeConvieneAPikachuUsarImpactruenoContraMeganiumSiEsteNoEstaNormal
meganium condicion:Dormido. "Elijo una condicion distinta de normal para probar"
self deny: (impactrueno convieneQue:pikachu TeUseContra:meganium). ! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/27/2013 20:37'!
testNoLeConvieneUsarDescansoAAsh
jigglypuff tePuedenSacrificar ifTrue:[
self deny:(golpazo convieneQue:jigglypuff TeUseContra:jigglypuff)].! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 16:44'!
testPikachuDerrotaAJigglypuff
pikachu luchaCon:placaje  contra:jigglypuff. 
meganium luchaCon:placaje contra:jigglypuff.
jigglypuff premiaALosGanadores. 
self assert:pikachu experiencia equals:42530. ! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 19:52'!
testPikachuEsNivel4
self assert: pikachu nivel equals:4.! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 20:51'!
testPikachuTiene1200DeGrositud.
self assert: pikachu cuantaGrositudTenes equals:1200.! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/27/2013 19:01'!
testPikachuUsaGolpazoContraJigglyPuffQuedaNoDisponible
pikachu luchaCon:golpazo contra:jigglypuff.
self assert:golpazo estasDisponible equals:false.  ! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/27/2013 19:01'!
testPikachuUsaGolpazoContraJigglyPuffSeMuere
pikachu luchaCon:golpazo contra:jigglypuff.
self assert:jigglypuff tusPuntosDeVida equals:0.! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 00:10'!
testPikachuUsaImpactruenoContraJigglypuffQuedaParalizado
pikachu luchaCon:impactrueno contra:jigglypuff.
self assert:(jigglypuff condicion) equals:Paralizado.  ! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 22:10'!
testUsarMedicinaConJiglypuffQuedaEn70
unaMedicina aplicarEn:jigglypuff. 
self assert:jigglypuff tusPuntosDeVida equals:70. ! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 22:09'!
testUsarMedicinaConPikachuQuedaIgualAMaxHP
pikachu tusPuntosDeVida:40. 
unaMedicina aplicarEn:pikachu.
self assert:pikachu tusPuntosDeVida equals:pikachu tusPuntosDeVidaMax. ! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 19:56'!
testUsarMedicinaEspecialEnJigglypoffQuedaNormal
jigglypuff condicion:Dormido. 
unaMedicinaEspecial aplicarEn:jigglypuff.
self assert:jigglypuff condicion equals:Normal. ! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 21:16'!
testUsarPokebolaConJiglypuffError
|errorDuenio|
errorDuenio:=EstePokemonYaTieneDuenioError new. 
self should:[unaPokebola aplicarEn:jigglypuff yTelatiro:unEntrenador] raise:Error.! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/26/2013 22:05'!
testUsarPokebolaConPikachuEn40
pikachu tusPuntosDeVida:40.
unaPokebola aplicarEn:pikachu yTelatiro:ash. 
self assert: (pikachu esDeAlguien)entrenador equals:ash. ! !

!TPIntegradorTest methodsFor: 'as yet unclassified' stamp: 'LucasGilone 10/28/2013 21:21'!
testUsarPokebolaConPikachuError 
[unaPokebola aplicarEn:pikachu yTelatiro:unEntrenador]on:Error do:[self assert:pikachu class equals:SinEntrenador].! !
